"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var order_properties_exports = {};
__export(order_properties_exports, {
  rule: () => rule
});
module.exports = __toCommonJS(order_properties_exports);
var import_sort_package_json = __toESM(require("sort-package-json"));
var import_createRule = require("../createRule.js");
const standardOrderLegacy = [
  "name",
  "version",
  "private",
  "publishConfig",
  "description",
  "main",
  "exports",
  "browser",
  "files",
  "bin",
  "directories",
  "man",
  "scripts",
  "repository",
  "keywords",
  "author",
  "license",
  "bugs",
  "homepage",
  "config",
  "dependencies",
  "devDependencies",
  "peerDependencies",
  "optionalDependencies",
  "bundledDependencies",
  "engines",
  "os",
  "cpu"
];
const rule = (0, import_createRule.createRule)({
  create(context) {
    return {
      "Program:exit"() {
        const { ast, text } = context.sourceCode;
        const options = {
          order: "sort-package-json",
          ...context.options[0]
        };
        const requiredOrder = options.order === "legacy" ? standardOrderLegacy : options.order;
        const orderedSource = (0, import_sort_package_json.default)(
          JSON.parse(text),
          requiredOrder === "sort-package-json" ? void 0 : {
            sortOrder: requiredOrder
          }
        );
        const orderedKeys = Object.keys(orderedSource);
        const { properties } = ast.body[0].expression;
        for (let i = 0; i < properties.length; i += 1) {
          if (properties[i].key.value !== orderedKeys[i]) {
            context.report({
              fix(fixer) {
                return fixer.replaceText(
                  context.sourceCode.ast,
                  JSON.stringify(orderedSource, null, 2) + `
`
                );
              },
              message: "Package top-level properties are not ordered in the npm standard way. Run the ESLint auto-fixer to correct.",
              node: context.sourceCode.ast
            });
          }
          break;
        }
      }
    };
  },
  meta: {
    docs: {
      category: "Best Practices",
      description: "Package properties must be declared in standard order",
      recommended: true
    },
    fixable: "code",
    schema: [
      {
        properties: {
          order: {
            anyOf: [
              {
                enum: ["legacy", "sort-package-json"],
                type: ["string"]
              },
              {
                items: {
                  type: ["string"]
                },
                type: ["array"]
              }
            ]
          }
        },
        type: "object"
      }
    ]
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  rule
});
//# sourceMappingURL=order-properties.js.map